package balance
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.MouseCursor;
	
	/* The base class for barTool, constPlumbTool and varPlumbTool.
	 * It keeps numbering, hence naming, and implements a basic binary tree structure.
	 * It also holds weighting. */
	
	public class balanceNode extends Sprite
	{
		// counter
		public static var nodeCounter:int = 0;
		
		// unique id => name
		public var id			:int		= 0;
		
		/* A node is not attached as far as it isn't in the container.
		 * A node remains free until a child is attached to it. If it isn't free it's unremovable. To release
		 * it, that is attache = false, you must first release its children. */		
		public var free			:Boolean	= true;	// *** code for free needs changes
		public var attached		:Boolean	= false;
		
		public var kind			:int		= -1;	// 0:bar, 1:constPlumb, 2:varPlumb
		
		public var parentNode	:*			= null;
		public var leftChild	:*			= null;
		public var rightChild	:*			= null;	// always null for plumbs
		
		public var weight		:Number		= 0;	// always 0 for bars
		public var leftWeight	:Number		= 0;	// always 0 for plumbs
		public var rightWeight	:Number		= 0;	// always 0 for plumbs
		
		
		public function balanceNode():void
		{
			nodeCounter++;
			id   = nodeCounter;
			name = id.toString();
			tabEnabled = false;
			
			buttonMode = true;
		}
	}
}