package balance
{
	import flash.display.Sprite;
	import flash.events.*;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	
	public class constPlumbTool extends balanceNode
	{
		public var plumb:constPlumbShape;
		public var editor:numEditor;
		private var initPoint:Point = new Point();		
		
		public function constPlumbTool():void
		{
			kind  = 1;
			
			plumb = new constPlumbShape();
			addChild(plumb);
			addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			
			editor = new numEditor();
			editor.x = -31;
			editor.y = 21;
			editor.visible = false;
			addChild(editor);
			
			editor.multiIO.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, onTextChange);
			editor.multiIO.addEventListener(FocusEvent.KEY_FOCUS_CHANGE, onTextChange);			
		}
		
		
		public function onTextChange(e:FocusEvent):void
		{
			background.currObj = editor.multiIO;
			editor.readInput();
			var tmp:Number = 0;
			weight = Math.round(weight * 10000) / 10000;
			if (attached)
			{
				if (weight > editor.numValue)
				{
					tmp = - Math.abs(weight - editor.numValue);
				}
				else
				{
					tmp = Math.abs(weight - editor.numValue);
				}
					
				background.runningWeight = tmp;				// initialize runningWeight
					
				background.weightPropagation(this);			// propagate weight upwards
					
				background.updatePos(background.rootBar);	// update positions of all objects downwards				
			}
			weight = editor.numValue;
		}
		
		
		public function followParent():void
		{
			if (parentNode != null)
			{
				var i:int = objArray.seekName(parentNode.name);
				var hang:Point = new Point();
				if (parentNode.leftChild == this)
				{
					hang = objArray.collision[i].collPoint;
				}
				else
				{
					hang = objArray.collision[i + 1].collPoint;
				}
				x = hang.x;
				y = hang.y;
				i = objArray.seekName(name);
				objArray.collision[i].collPoint = localToGlobal(plumb.hookPoint);				
			}
		}		
		
		
		public function savePos():void
		{
			initPoint.x = x;
			initPoint.y = y;			
		}
		
		
		private function onMouseDown(event:MouseEvent):void
		{
			if (free == true)
			{			
				addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
				addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
				savePos();
				startDrag();
			}
		}
		
		private function onMouseMove(event:MouseEvent):void
		{
			if (!attached)
			{			
				var test:int = objArray.minDistance(localToGlobal(plumb.linkPoint));
				if (test > -1)
				{
					alpha = 1;
				}
				else 
				{
					alpha = 0.5;
				}
			}
		}		
		
		private function onMouseUp(event:MouseEvent):void
		{
			removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			removeEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
			stopDrag();
			if (attached)
			{
				unPlug();
			}
			else
			{			
				plug();
			}
		}	
		
		
		public function plug():void
		{
			var test:int = objArray.minDistance(localToGlobal(plumb.linkPoint));
			if (test > -1)
			{
				objArray.collision[test].free = false;			// this point is no more available
				objArray.collision[test].objRef.free = false;	// parent can't move anymore
				
				if (objArray.collision[test].direction == 0)
				{
					objArray.collision[test].objRef.leftChild = this;
				}
				else
				{
					objArray.collision[test].objRef.rightChild = this;
				}
				
				background.container.addChild(this);
				alpha = 1;
				attached = true;
				editor.visible = true;
				x = objArray.collision[test].collPoint.x;
				y = objArray.collision[test].collPoint.y;
				parentNode = objArray.collision[test].objRef;
				
				var l:collData = new collData();
				l.collPoint = localToGlobal(plumb.hookPoint);
				l.free = true;
				l.direction = 0;
				l.objRef = this;
				objArray.collision.push(l);
				var r:collData = new collData();
				r.collPoint = (0,0) as Point;
				r.free = false;
				r.direction = 1;
				r.objRef = this;
				objArray.collision.push(r);
				
				background.runningWeight = weight;			// initialize runningWeight
					
				background.weightPropagation(this);			// propagate weight upwards
					
				background.updatePos(background.rootBar);	// update positions of all objects downwards					
			}
			else
			{
				x = 45;
				y = 500;
				free = false;
				buttonMode = false;
				background.fadeInOut(this, false);				
			}			
		}
		
		
		public function unPlug():void
		{
			var currentPoint:Point = new Point();
			currentPoint.x = x;
			currentPoint.y = y;
			var dist:Number = Point.distance(initPoint, currentPoint);
			
			if (dist > 30)
			{
				background.runningWeight = -weight;			// initialize runningWeight
				background.weightPropagation(this);			// propagate weight upwards
				background.updatePos(background.rootBar);	// update positions of all objects downwards	
					
				// delete the entries in collision list
				i = objArray.seekName(name);
				objArray.collision.splice(i, 2);				
				
				attached = false;
				alpha	 = 0.5;
				weight	 = 0;
				x = 180;
				y = 28;
				editor.nullify();
				editor.visible = false;
				
				// release the parent's point in collision list
				var i:int = objArray.seekName(parentNode.name);
				if (parentNode.leftChild == this)
				{
					objArray.collision[i].free = true;
					parentNode.leftChild = null;
				}
				else
				{
					objArray.collision[i + 1].free = true;
					parentNode.rightChild = null;
				}
					
				// if parent has no more children then it's free
				if (parentNode != background.rootBar)
				{
					if (parentNode.leftChild == null && parentNode.rightChild == null)
					{
						parentNode.free = true;
					}
				}
				
				x = 45;
				y = 500;
				free = false;
				buttonMode = false;
				background.fadeInOut(this, false);
			}
			else
			{
				x = initPoint.x;
				y = initPoint.y;
			}
		}		
	}
}