package balance
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	public class numEditor extends Sprite
	{
		public var numValue     :Number 	= 0.0;
		public var multiIO      :TextField 	= new TextField();
		public var integralPart :TextField 	= new TextField();
		public var decimalPart  :TextField 	= new TextField();
		public var numerator    :TextField 	= new TextField();
		public var denominator  :TextField 	= new TextField();
		public var fracLine		:Shape 		= new Shape();
		public const INTEGER	:String 	= "INTEGER";
		public const DECIMAL	:String 	= "DECIMAL";
		public const FRACTION	:String 	= "FRACTION";
		public const MIXED		:String 	= "MIXED";
		public const WRONG		:String		= "WRONG";
		public var numKind		:String;
		
		public function numEditor():void
		{
			init();
		}
		
		private function init():void
		{	
			multiIO.type = TextFieldType.INPUT;
			multiIO.name = "plumb";
			multiIO.width  = 60;
			multiIO.height = 20;
			multiIO.restrict = "0-9. /";
			multiIO.maxChars = 11;
			multiIO.x = 0;
			multiIO.y = 5;
			multiIO.visible = false;
			addChild(multiIO);		
			
			integralPart.type = TextFieldType.DYNAMIC;
			integralPart.width = 25;
			addChild(integralPart);
			
			decimalPart.type = TextFieldType.DYNAMIC;
			decimalPart.width = 30;
			decimalPart.selectable = false;
			addChild(decimalPart);				
			
			numerator.type = TextFieldType.DYNAMIC;
			numerator.width = 30;
			numerator.selectable = false;
			addChild(numerator);
			
			fracLine.graphics.beginFill(0x6699CC);
			fracLine.graphics.drawRect(28, 15, 30, 1);
			fracLine.graphics.endFill();
			addChild(fracLine);
			
			denominator.type = TextFieldType.DYNAMIC;
			denominator.width  = 30;
			denominator.selectable = false;
			addChild(denominator);
			
			nullify();
			
			addEventListener(FocusEvent.FOCUS_IN, showEditor);
		}
		
		public function nullify():void
		{
			numKind = INTEGER;
			multiIO.text = "0";
			integralPart.text = "0";
			numValue = 0;
			adjPos(numKind);			
		}
		
		public function showEditor(e:FocusEvent):void
		{
			multiIO.visible		 = true;
			integralPart.visible = false;
			decimalPart.visible  = false;
			fracLine.visible     = false;
			numerator.visible    = false;
			denominator.visible  = false;			
		}
		
		
		public function adjPos(k:String):void
		{
			multiIO.visible		 = false;
			integralPart.visible = false;
			decimalPart.visible  = false;
			fracLine.visible     = false;
			numerator.visible    = false;
			denominator.visible  = false;
			
			var format:TextFormat = new TextFormat();
			format.align = TextFormatAlign.RIGHT;
			integralPart.setTextFormat(format);
			format.align = TextFormatAlign.LEFT;
			decimalPart.setTextFormat(format);
			format.align = TextFormatAlign.CENTER;
			numerator.setTextFormat(format);
			format.align = TextFormatAlign.CENTER;
			denominator.setTextFormat(format);			
			
			switch (k)
			{
				case INTEGER : 	integralPart.x	= 17;
								integralPart.y	= 5;
								integralPart.visible = true;
								break;
				case DECIMAL : 	integralPart.x	= 7;
								integralPart.y	= 5;
								decimalPart.x	= 27;
								decimalPart.y	= 5;
								integralPart.visible = true;
								decimalPart.visible  = true;
								break;
				case FRACTION: 	fracLine.x		= -13;
								fracLine.y		= 0;
								numerator.x		= 15;
								numerator.y		= -2;
								denominator.x	= 15;
								denominator.y	= 14;
								fracLine.visible     = true;
								numerator.visible    = true;
								denominator.visible  = true;
								break;
				case MIXED	 : 	integralPart.x	= 0;
								integralPart.y	= 5;
								fracLine.x		= 0;
								fracLine.y		= 0;
								numerator.x		= 28;
								numerator.y		= -2;
								denominator.x	= 28;
								denominator.y	= 14;
								integralPart.visible = true;
								fracLine.visible     = true;
								numerator.visible    = true;
								denominator.visible  = true;
			}
			
		}
		
		public function readInput():void
		{
			var sentinel  :String  = "integralPart";
			var char	  :String  = "";
			var i		  :int	   = 0;
			var spaceFound:Boolean = false;
			var dotFound  :Boolean = false;
			var slashFound:Boolean = false;
			const SPACE	  :String  = " ";
			const DOT	  :String  = ".";
			const SLASH	  :String  = "/";
			
			integralPart.text	= "";
			decimalPart.text	= "";
			numerator.text		= "";
			denominator.text	= "";
			
			for (i= 0; i < multiIO.length; i++)
			{
				char = multiIO.text.charAt(i);
				if (char != SPACE && char != DOT && char != SLASH)
				{
					switch (sentinel)
					{
						case "integralPart"	: integralPart.appendText(multiIO.text.charAt(i));
											  break;
						case "numeratorPart": numerator.appendText(multiIO.text.charAt(i));
											  break;
						case "decimalPart"	: decimalPart.appendText(multiIO.text.charAt(i));
											  break;
						case "denominator"	: denominator.appendText(multiIO.text.charAt(i));
					}
				}
				else
				{
					switch (char)
					{
						case SPACE	:	if (sentinel == "integralPart")
										{
											sentinel = "numeratorPart";
										}
										else
										{
											sentinel = "wrong";
										}
										spaceFound = true;
										break;
						case DOT	:	if (sentinel == "integralPart")
										{
											sentinel = "decimalPart";
										}
										else
										{
											sentinel = "wrong";
										}
										dotFound = true;
										break;
						case SLASH	:	if (sentinel == "integralPart")
										{
											numerator.text = integralPart.text;
											integralPart.text = "";
											sentinel = "denominator";
										}
										else
										{
											if (sentinel == "numeratorPart")
											{
												sentinel = "denominator";
											}
											else
											{
												sentinel = "wrong";
											}
										}
										slashFound = true;
					}
				}
			}
			
			var buff:String;
			if (integralPart.length > 3)
			{
				buff = ""
				for (i = 0; i < 3; i++)
				{
					buff += integralPart.text.charAt(i);
				}
				integralPart.text = buff;
			}
			var intPart:int = parseInt(integralPart.text);
			if (isNaN(intPart))
			{
				integralPart.text = "0";
				intPart = 0;
			}
			if (decimalPart.length > 3)
			{
				buff = ""
				for (i = 0; i < 3; i++)
				{
					buff += decimalPart.text.charAt(i);
				}
				decimalPart.text = buff;
			}
			var decPart:int = parseInt(decimalPart.text);
			if (isNaN(decPart))
			{
				decimalPart.text = ".0";
			}
			else
			{
				decimalPart.text = "." + decimalPart.text;
			}
			if (numerator.length > 3)
			{
				buff = ""
				for (i = 0; i < 3; i++)
				{
					buff += numerator.text.charAt(i);
				}
				numerator.text = buff;
			}
			var numPart:int = parseInt(numerator.text);
			if (isNaN(numPart))
			{
				numerator.text = "0";
				numPart = 0;
			}
			if (denominator.length > 3)
			{
				buff = ""
				for (i = 0; i < 3; i++)
				{
					buff += denominator.text.charAt(i);
				}
				denominator.text = buff;
			}
			var denPart:int = parseInt(denominator.text);
			if (isNaN(denPart) || denPart == 0)
			{
				denominator.text = "1";
				denPart = 1;
			}
			
			numKind = WRONG;
			if (sentinel != "wrong")
			{
				if (spaceFound && slashFound && !dotFound)
				{
					numValue = intPart + numPart / denPart;
					numKind  = MIXED;
				}
				if (!spaceFound && slashFound && !dotFound)
				{
					numValue = numPart / denPart;
					numKind  = FRACTION;
				}
				if (!spaceFound && !slashFound && dotFound)
				{
					numValue = intPart + parseFloat(decimalPart.text);
					numKind  = DECIMAL;
				}
				if (!spaceFound && !slashFound && !dotFound)
				{
					numValue = intPart;
					numKind  = INTEGER;
				}
			}
			
			if (numKind == WRONG)
			{
				numKind  = INTEGER;
				integralPart.text = "0";
				numValue = 0;
			}
			
			numValue = Math.round(numValue * 10000) / 10000;
			adjPos(numKind);
		}
	}
}