package balance
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.geom.Point;	
	
	public class objArray extends Sprite
	{
		public static var collision :Array;		// keeps the hang points
		public static var ioArray   :Array;		// for io purposes
		public static var readArray :Array;
		
		public function objArray():void
		{
			collision = new Array();
			ioArray   = new Array();
			readArray = new Array();
		}
		
		
		public static function newNode(childID:String, hookPoint:Point):void
		{
			var j:int = 0;
			do 
			{
				j++;
			} while (j < ioArray.length && (ioArray[j] as ioNode).id != childID);
			if (j != 0)
			{
				switch ((ioArray[j] as ioNode).kind)
				{
					case 0:
						var b:ioBar = new ioBar();
						b = (ioArray[j] as ioBar);
						b.newBar(childID, hookPoint);
						break;
					case 1:
						var c:ioConst = new ioConst();
						c = (ioArray[j] as ioConst);
						c.newConst(childID, hookPoint);						
						break;
					case 2:
						var v:ioVar = new ioVar();
						v = (ioArray[j] as ioVar);
						v.newVar(childID, hookPoint);
				}
			}
		}
		
		
		public static function buildMe():void
		{
			for (var i:int = 0; i < ioArray.length; i++)
			{
				switch ((ioArray[i] as ioNode).kind)
				{
					case 0:
						var outBar:ioBar = new ioBar();
						outBar = (ioArray[i] as ioBar);
						var b:int = seekName(outBar.id);
						if (outBar.child != "-1")
						{	
							newNode(outBar.child, collision[b].collPoint);
						}
						if (outBar.rightChild != "-1")
						{
							newNode(outBar.rightChild, collision[b + 1].collPoint);
						}
						break;
					case 1:
						var outConst:ioConst = new ioConst();
						outConst = (ioArray[i] as ioConst);
						var c:int = seekName(outConst.id);
						if (outConst.child != "-1")
						{
							newNode(outConst.child, collision[c].collPoint);
						}						
						break;
					case 2:
						var outVar:ioVar = new ioVar();
						outVar = (ioArray[i] as ioVar);
						var v:int = seekName(outVar.id);
						if (outVar.child != "-1")
						{
							newNode(outVar.child, collision[v].collPoint);
						}						
				}
			}
		}
		
		
		public static function ioArray_read():void
		{
			ioArray = [];
			for (var i:int = 0; i < readArray.length; i++)
			{
				var buff:Array = (readArray[i] as String).split(";");
				switch (buff[1])
				{
					case "0":
						var outBar  :ioBar	= new ioBar();
						outBar.id			= buff[0];
						outBar.kind			= 0;
						outBar.parent		= buff[2];
						outBar.child		= buff[3];
						outBar.rightChild	= buff[4];
						ioArray.push(outBar);
						break;
					case "1":
						var outConst:ioConst= new ioConst();
						outConst.id			= buff[0];
						outConst.kind		= 1;
						outConst.parent		= buff[2];
						outConst.child		= buff[3];
						outConst.weight		= parseFloat(buff[4]);
						outConst.numText	= buff[5];
						ioArray.push(outConst);
						break;
					case "2":
						var outVar  :ioVar	= new ioVar();
						outVar.id			= buff[0];
						outVar.kind			= 2;
						outVar.parent		= buff[2];
						outVar.child		= buff[3];
						outVar.weight		= parseFloat(buff[4]);
						outVar.symbol		= buff[5];
						outVar.x_1			= parseFloat(buff[6]);
						outVar.x_2			= parseFloat(buff[7]);
						outVar.step			= parseFloat(buff[8]);
						ioArray.push(outVar);
				}
			}
			buildMe();
		}
		
		
		public static function ioArray_write():void
		{
			var tmp:DisplayObject;
			
			ioArray = [];
			for (var i:uint = 0; i < background.container.numChildren ; i++)
			{
				tmp = background.container.getChildAt(i);
				if (tmp is balanceNode)
				{
					if ((tmp as balanceNode).attached)
					{
						switch ((tmp as balanceNode).kind)	// 0:bar, 1:constPlumb, 2:varPlumb
						{
							case 0:
								var outBar  :ioBar	= new ioBar();
								outBar.id			= (tmp as balanceNode).name;
								outBar.kind			= 0;
								if ((tmp as balanceNode).parentNode != null)
								{
									outBar.parent	= (tmp as balanceNode).parentNode.name;
								}
								if ((tmp as balanceNode).leftChild != null)
								{
									outBar.child	= (tmp as balanceNode).leftChild.name;
								}
								if ((tmp as balanceNode).rightChild != null)
								{
									outBar.rightChild	= (tmp as balanceNode).rightChild.name;
								}
								ioArray.push(outBar);
								break;
							case 1:
								var outConst:ioConst= new ioConst();
								outConst.id			= (tmp as balanceNode).name;
								outConst.kind		= 1;
								outConst.parent		= (tmp as balanceNode).parentNode.name;
								if ((tmp as balanceNode).leftChild != null)
								{
									outConst.child	= (tmp as balanceNode).leftChild.name;									
								}
								outConst.weight		= (tmp as balanceNode).weight;
								outConst.numText	= (tmp as constPlumbTool).editor.multiIO.text;
								ioArray.push(outConst);
								break;
							case 2:
								var outVar  :ioVar	= new ioVar();
								outVar.id			= (tmp as balanceNode).name;
								outVar.kind			= 2;
								outVar.parent		= (tmp as balanceNode).parentNode.name;
								if ((tmp as balanceNode).leftChild != null)
								{
									outVar.child	= (tmp as balanceNode).leftChild.name;									
								}
								outVar.weight		= (tmp as balanceNode).weight;
								outVar.symbol		= (tmp as varPlumbTool).symbol;
								outVar.x_1			= (tmp as varPlumbTool).x_1;
								outVar.x_2			= (tmp as varPlumbTool).x_2;
								outVar.step			= (tmp as varPlumbTool).step;
								ioArray.push(outVar);							
						}
					}
				}
			}
		}
		
		
		
		
		// finds the first entry that corresponds to the caller
		public static function seekName(refName:String):int
		{
			var i:int;
			for (i = 0; i < collision.length; i++)
			{
				if (collision[i].objRef.name == refName)
				{
					return i;
				}
			}
			return -1;
		}
		
		/* Given refPoint, calculates the distances from all free entry points
		 * and finds the minimum. If it's less than 20 it returns the corresponding entry,
		 * otherwise it returns -1 */
		public static function minDistance(refPoint:Point):int
		{
			var i:int;
			var id:int  = -1;
			var min:Number = 10000.0;
			var tmp:Number = -1;
			for (i = 0; i < collision.length; i++)
			{
				if (collision[i].free == true)
				{
					tmp = Point.distance(refPoint, collision[i].collPoint);
					if (tmp < min)
					{
						min = tmp;
						id  = i;
					}
				}
			}
			if (min < 20)
			{
				return id;
			}
			else
			{
				return -1;
			}
		}
		
	}
}