package balance
{
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFieldAutoSize;
	
	public class varPlumbTool extends balanceNode
	{
		public var plumb:varPlumbShape;
		public var txt:TextField;
		public var label:TextField;
		public var symbol:String	= "?";
		public var x_1:Number  		= 0;
		public var x_2:Number  		= 1;
		public var step:Number 		= 0.1;
		private var initPoint:Point = new Point();
		
		public function varPlumbTool():void
		{
			kind  = 2;
			initData();
			
			plumb  = new varPlumbShape();
			addChild(plumb);
			
			label = new TextField();
			label.type = TextFieldType.DYNAMIC;
			label.autoSize = TextFieldAutoSize.CENTER;
			label.text = symbol;
			label.width = 30;
			label.height = 20;
			label.x = -35;
			label.y = 10;
			label.selectable = false;
			label.background = true;
			label.backgroundColor = 0x0066CC;
			label.textColor = 0xFFFFFF;
			addChild(label);
			
			txt = new TextField();
			txt.type = TextFieldType.DYNAMIC;
			txt.text   = weight.toString();
			txt.width  = 60;
			txt.height = 20;
			txt.x = -30;
			txt.y = 30;
			txt.selectable = false;
			addChild(txt);
			
			addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);			
		}
		
		
		private function initData():void
		{
			var tmp:DisplayObject;
			var i:int = 0;
			var sentinel:Boolean = true;
			do
			{
				tmp = background.container.getChildAt(i);
				if (tmp is varPlumbTool && (tmp as varPlumbTool).symbol == "x")
				{
					sentinel = false;
					x_1 	= (tmp as varPlumbTool).x_1;
					x_2 	= (tmp as varPlumbTool).x_2;
					step 	= (tmp as varPlumbTool).step;
					weight	= (tmp as varPlumbTool).weight;
				}
				i++;
			}
			while (i < background.container.numChildren && sentinel);
		}		
		
		
		public function followParent():void
		{
			if (parentNode != null)
			{
				var i:int = objArray.seekName(parentNode.name);
				var hang:Point = new Point();
				if (parentNode.leftChild == this)
				{
					hang = objArray.collision[i].collPoint;
				}
				else
				{
					hang = objArray.collision[i + 1].collPoint;
				}
				x = hang.x;
				y = hang.y;
				i = objArray.seekName(name);
				objArray.collision[i].collPoint = localToGlobal(plumb.hookPoint);				
			}
		}		
		
		public function savePos():void
		{
			initPoint.x = x;
			initPoint.y = y;			
		}
		
		private function onMouseDown(event:MouseEvent):void
		{
			slider.oldName		= symbol;
			slider.nameStr.text	= symbol;
			slider.fromStr.text	= x_1.toString();
			slider.toStr.text	= x_2.toString();
			slider.stepStr.text	= step.toString();
			slider.fromValue 	= x_1;
			slider.toValue 		= x_2;
			slider.stepValue 	= step;
			slider.weightValue	= weight;
			slider.deModulate();
			
			if (free == true)
			{	
				addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
				addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);				
				savePos();
				startDrag();
			}
		}
		
		private function onMouseMove(event:MouseEvent):void
		{
			if (!attached)
			{			
				var test:int = objArray.minDistance(localToGlobal(plumb.linkPoint));
				if (test > -1)
				{
					alpha = 1;
				}
				else 
				{
					alpha = 0.5;
				}
			}
		}
		
		private function onMouseUp(event:MouseEvent):void
		{
			removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			removeEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
			stopDrag();
			if (attached)
			{
				unPlug();
			}
			else
			{			
				plug();
			}
		}	
		
		
		public function plug():void
		{
			var test:int = objArray.minDistance(localToGlobal(plumb.linkPoint));
			if (test > -1)
			{
				objArray.collision[test].free = false;			// this point is no more available
				objArray.collision[test].objRef.free = false;	// parent can't move anymore
				
				if (objArray.collision[test].direction == 0)
				{
					objArray.collision[test].objRef.leftChild = this;
				}
				else
				{
					objArray.collision[test].objRef.rightChild = this;
				}
				
				background.container.addChild(this);
				alpha = 1;
				attached = true;
				x = objArray.collision[test].collPoint.x;
				y = objArray.collision[test].collPoint.y;
				parentNode = objArray.collision[test].objRef;
				
				var l:collData = new collData();
				l.collPoint = localToGlobal(plumb.hookPoint);
				l.free = true;
				l.direction = 0;
				l.objRef = this;
				objArray.collision.push(l);
				var r:collData = new collData();
				r.collPoint = (0,0) as Point;
				r.free = false;
				r.direction = 1;
				r.objRef = this;
				objArray.collision.push(r);
					
				background.runningWeight = weight;			// initialize runningWeight
					
				background.weightPropagation(this);			// propagate weight upwards
					
				background.updatePos(background.rootBar);	// update positions of all objects downwards					
			}
			else
			{
				x = 45;
				y = 500;
				free = false;
				buttonMode = false;
				background.fadeInOut(this, false);				
			}
		}
		
		
		public function unPlug():void
		{
			var currentPoint:Point = new Point();
			currentPoint.x = x;
			currentPoint.y = y;
			var dist:Number = Point.distance(initPoint, currentPoint);
			
			if (dist > 30)
			{
				background.runningWeight = -weight;			// initialize runningWeight
				background.weightPropagation(this);			// propagate weight upwards
				background.updatePos(background.rootBar);	// update positions of all objects downwards
				
				// delete the entries in collision list
				i = objArray.seekName(name);
				objArray.collision.splice(i, 2);				
				
				attached = false;
				alpha	 = 0.5;			
				x = 180;
				y = 28;
				
				// release the parent's point in collision list
				var i:int = objArray.seekName(parentNode.name);
				if (parentNode.leftChild == this)
				{
					objArray.collision[i].free = true;
					parentNode.leftChild = null;
				}
				else
				{
					objArray.collision[i + 1].free = true;
					parentNode.rightChild = null;
				}
					
				// if parent has no more children then it's free
				if (parentNode != background.rootBar)
				{
					if (parentNode.leftChild == null && parentNode.rightChild == null)
					{
						parentNode.free = true;
					}
				}
				
				x = 45;
				y = 500;
				free = false;
				buttonMode = false;
				background.fadeInOut(this, false);
			}
			else
			{
				x = initPoint.x;
				y = initPoint.y;
			}
		}		
	}
}